#include <winioctl.h>
#include <signal.h>
#include "wincon.h"
#include "console.h"


#define IOCTL_CONSOLE_VALIDATEHANDLE					CTL_CODE(FILE_DEVICE_CONSOLE, 102, METHOD_BUFFERED, FILE_ANY_ACCESS)

#define IOCTL_CONSOLE_PEEKCONSOLEINPUT					CTL_CODE(FILE_DEVICE_CONSOLE, 110, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_CONSOLE_READCONSOLEINPUT					CTL_CODE(FILE_DEVICE_CONSOLE, 111, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_CONSOLE_WRITECONSOLEINPUT					CTL_CODE(FILE_DEVICE_CONSOLE, 112, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_CONSOLE_READCONSOLEOUTPUT					CTL_CODE(FILE_DEVICE_CONSOLE, 113, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_CONSOLE_WRITECONSOLEOUTPUT				CTL_CODE(FILE_DEVICE_CONSOLE, 114, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_CONSOLE_READCONSOLEOUTPUTCHARACTERW		CTL_CODE(FILE_DEVICE_CONSOLE, 115, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_CONSOLE_READCONSOLEOUTPUTCHARACTERA		CTL_CODE(FILE_DEVICE_CONSOLE, 116, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_CONSOLE_READCONSOLEOUTPUTATTRIBUTE		CTL_CODE(FILE_DEVICE_CONSOLE, 117, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_CONSOLE_WRITECONSOLEOUTPUTCHARACTERW		CTL_CODE(FILE_DEVICE_CONSOLE, 118, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_CONSOLE_WRITECONSOLEOUTPUTCHARACTERA		CTL_CODE(FILE_DEVICE_CONSOLE, 119, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_CONSOLE_WRITECONSOLEOUTPUTATTRIBUTE		CTL_CODE(FILE_DEVICE_CONSOLE, 120, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_CONSOLE_FILLCONSOLEOUTPUTCHARACTERW		CTL_CODE(FILE_DEVICE_CONSOLE, 121, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_CONSOLE_FILLCONSOLEOUTPUTCHARACTERA		CTL_CODE(FILE_DEVICE_CONSOLE, 122, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_CONSOLE_FILLCONSOLEOUTPUTATTRIBUTE		CTL_CODE(FILE_DEVICE_CONSOLE, 123, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_CONSOLE_GETCONSOLEMODE					CTL_CODE(FILE_DEVICE_CONSOLE, 124, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_CONSOLE_GETNUMBEROFCONSOLEINPUTEVENTS		CTL_CODE(FILE_DEVICE_CONSOLE, 125, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_CONSOLE_GETCONSOLESCREENBUFFERINFO		CTL_CODE(FILE_DEVICE_CONSOLE, 126, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_CONSOLE_GETLARGESTCONSOLEWINDOWSIZE		CTL_CODE(FILE_DEVICE_CONSOLE, 127, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_CONSOLE_GETCONSOLECURSORINFO				CTL_CODE(FILE_DEVICE_CONSOLE, 128, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_CONSOLE_GETNUMBEROFCONSOLEMOUSEBUTTONS	CTL_CODE(FILE_DEVICE_CONSOLE, 129, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_CONSOLE_SETCONSOLEMODE					CTL_CODE(FILE_DEVICE_CONSOLE, 130, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_CONSOLE_SETACTIVESCREENBUFFER				CTL_CODE(FILE_DEVICE_CONSOLE, 131, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_CONSOLE_FLUSHCONSOLEINPUTBUFFER			CTL_CODE(FILE_DEVICE_CONSOLE, 132, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_CONSOLE_SETCONSOLESCREENBUFFERSIZE		CTL_CODE(FILE_DEVICE_CONSOLE, 133, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_CONSOLE_SETCONSOLECURSORPOSITION			CTL_CODE(FILE_DEVICE_CONSOLE, 134, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_CONSOLE_SETCONSOLECURSORINFO				CTL_CODE(FILE_DEVICE_CONSOLE, 135, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_CONSOLE_SCROLLCONSOLESCREENBUFFER			CTL_CODE(FILE_DEVICE_CONSOLE, 136, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_CONSOLE_SETCONSOLEWINDOWINFO				CTL_CODE(FILE_DEVICE_CONSOLE, 137, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_CONSOLE_SETCONSOLETEXTATTRIBUTE			CTL_CODE(FILE_DEVICE_CONSOLE, 138, METHOD_BUFFERED, FILE_ANY_ACCESS)

#define IOCTL_CONSOLE_GENERATECONSOLECTRLEVENT			CTL_CODE(FILE_DEVICE_CONSOLE, 139, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_CONSOLE_SETCONSOLETITLEW					CTL_CODE(FILE_DEVICE_CONSOLE, 140, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_CONSOLE_SETCONSOLETITLEA					CTL_CODE(FILE_DEVICE_CONSOLE, 141, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_CONSOLE_GETCONSOLETITLEW					CTL_CODE(FILE_DEVICE_CONSOLE, 142, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_CONSOLE_GETCONSOLETITLEA					CTL_CODE(FILE_DEVICE_CONSOLE, 143, METHOD_BUFFERED, FILE_ANY_ACCESS)

#define IOCTL_CONSOLE_READCONSOLEW						CTL_CODE(FILE_DEVICE_CONSOLE, 144, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_CONSOLE_READCONSOLEA						CTL_CODE(FILE_DEVICE_CONSOLE, 145, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_CONSOLE_WRITECONSOLEW						CTL_CODE(FILE_DEVICE_CONSOLE, 146, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_CONSOLE_WRITECONSOLEA						CTL_CODE(FILE_DEVICE_CONSOLE, 147, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_CONSOLE_CREATECONSOLESCREENBUFFER			CTL_CODE(FILE_DEVICE_CONSOLE, 148, METHOD_BUFFERED, FILE_ANY_ACCESS)




typedef struct _SetHandlerRoutineData
{
	PHANDLER_ROUTINE pfnHandler;
	BOOL bAdd;
}SetHandlerRoutineData;

typedef struct _PeekConsoleInputData
{
  HANDLE hConsoleInput;        // handle to input buffer
	PINPUT_RECORD lpBuffer;       // peek data
  DWORD nLength;                // number of records to read
  DWORD lpNumberOfEventsRead;  // number of records read
}PeekConsoleInputData;

typedef struct _FillConsoleOutputCharacterData
{ 
  WCHAR cCharacter;               // character
  DWORD nLength;                  // number of cells
  COORD dwWriteCoord;             // first coordinates
}FillConsoleOutputCharacterData;


typedef struct _FillConsoleOutputAttributeData
{ 
  WORD wAttribute;                // color attribute
  DWORD nLength;                  // number of cells
  COORD dwWriteCoord;             // first coordinates
}FillConsoleOutputAttributeData;


typedef struct _WriteConsoleOutputData
{ 
  CONST CHAR_INFO *lpBuffer;  // data buffer
  COORD dwBufferSize;         // size of data buffer
  COORD dwBufferCoord;        // cell coordinates
  PSMALL_RECT lpWriteRegion;   // rectangle to write
}WriteConsoleOutputData;


typedef struct _WriteConsoleOutputCharacterData
{ 
  LPVOID lpCharacter;			  // characters
  DWORD nLength;                  // number of cells
  COORD dwWriteCoord;             // first coordinates
}WriteConsoleOutputCharacterData;


typedef struct _WriteConsoleOutputAttributeData
{ 
	CONST WORD *lpAttribute;       // write attributes
	DWORD nLength;                 // number of cells
	COORD dwWriteCoord;            // first cell coordinates
}WriteConsoleOutputAttributeData;

typedef struct _ReadConsoleOutputCharacterData
{
  LPVOID lpCharacter;          // character buffer
  DWORD nLength;               // number of cells to read
  COORD dwReadCoord;           // coordinates of first cell
}ReadConsoleOutputCharacterData;

typedef struct _ReadConsoleOutputAttributeData
{
  LPWORD lpAttribute;          // attributes  buffer
  DWORD nLength;               // number of cells to read
  COORD dwReadCoord;           // coordinates of first cell
}ReadConsoleOutputAttributeData;

typedef struct _ReadConsoleOutputWData
{
	PCHAR_INFO lpBuffer;       // data buffer
	COORD dwBufferSize;        // column-row size of buffer
	COORD dwBufferCoord;       // upper-left cell to write
	PSMALL_RECT lpReadRegion;   // read rectangle
}ReadConsoleOutputWData;

typedef struct _GetNumberOfConsoleInputEventsData
{
  HANDLE hConsoleInput;       // handle to console input buffer
  DWORD  NumberOfEvents;     // [out] number of events
}GetNumberOfConsoleInputEventsData;

typedef struct _ScrollConsoleScreenBufferData
{
	CONST SMALL_RECT *lpScrollRectangle; // scroll rectangle
	CONST SMALL_RECT *lpClipRectangle;   // clipping rectangle
	COORD dwDestinationOrigin;           // new location
	CONST CHAR_INFO *lpFill;              // fill character and color
}ScrollConsoleScreenBufferData;